function make_graphs
/* Graphical objects */
create xform /graph1 [10,20,600,400]

create xgraph /graph1/voltage -title "Voltage" -hgeom 50% -wgeom 50%
setfield ^ XUnits mSec YUnits mM xmax 13e3 ymin -120 ymax -50
create xgraph /graph1/conclow -title "Concentration" -hgeom 50% -wgeom 50%
setfield ^ XUnits mSec YUnits nA xmax  13e3 ymin 0 ymax 12
create xgraph /graph1/conchi -title "Concentration" -xgeom 300 -ygeom 0 -hgeom 50% -wgeom 50%
setfield ^ XUnits mSec ymax 120 ymin 20 xmax 13e3
create xgraph /graph1/current -title "current" -xgeom 300 -hgeom 50% -wgeom 50%
setfield ^ XUnits mSec  xmax 13e3 ymax 0.05 ymin -0.05
xshow /graph1

addmsg clin /graph1/conclow PLOT Conc  *CLin *white
addmsg clout /graph1/conchi PLOT Conc *CLout *white
addmsg kin /graph1/conchi PLOT Conc  *Kin *black
addmsg kout /graph1/conclow PLOT Conc  *Kout *black
addmsg clrev /graph1/voltage PLOT E  *Ecl *white
addmsg krev /graph1/voltage PLOT E *Ek *black
addmsg vm /graph1/voltage PLOT Vm  *Vm *red
addmsg clchan /graph1/current PLOT Ik *Icl *white
addmsg kchan /graph1/current PLOT Ik *Ik *black
reset

end

function change_cl

step 2000 
setfield clout Conc 30
step 6000

setfield clout Conc 120
step 5000
end

function change_k
step 2000 
setfield kout Conc 10
step 6000

setfield kout Conc 2.5
step 5000
end

function set_cl(dialog)
    str dialog

    float newcl
    newcl = {getfield {dialog} value}

step 2000 
setfield clout Conc {newcl}
step 6000

setfield clout Conc 120
step 5000
end

function set_k(dialog)
    str dialog
    float newk

    newk = {getfield {dialog} value}

step 2000 
setfield kout Conc {newk}
step 6000

setfield kout Conc 2.5
step 5000
end


function make_control
    create xform /control [610,20,250,170]
    create xlabel /control/label -hgeom 50 -bg cyan -label "CONTROL PANEL"
    create xbutton /control/RESET -wgeom 50%       -script reset
    create xbutton /control/QUIT -xgeom 0:RESET -ygeom 0:label -wgeom 50% \
        -script quit
    create xbutton /control/Chloride   -ygeom 0:RESET -wgeom 50% \
        -script change_cl
    create xbutton /control/potassium  -xgeom 0:Chloride -ygeom 0:RESET -wgeom 50% \ 
       -script change_k
    create xdialog /control/Clout -label "External chloride" \
                -value 120.0 -script "set_cl <widget>"
    create xdialog /control/Kout -label "External potassium" \
                -value 1 -script "set_k <widget>"

    xshow /control
end
